//WitSummon para Linux by TxaKy
//Este programa utiliza las bibliotecas gtk+, glib y glib
//asi que si piensas compilarlo necesitas instalarlas.
//
//La version para desarrollo de cualquiera de ellas se encuentra
//en cualquiera de las distribuciones de linux actuales, aunque no 
//siempre vienen instaladas por defecto.
//
//Ale a jugar que son dos dias....
//

#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>

#include <gtk/gtk.h>

//Declaracion de funciones
gint Destroy(GtkWidget *widget, gpointer gdata);
void DoConnect (GtkWidget *widget, gpointer gdata);

//variables globales
GtkWidget *status;
GtkWidget *cchannel;
GtkWidget *lbutton;
int conectado=0;

//Funcion main
int main(int argc, char *argv[])
{
	GtkWidget *main_window;
	GtkWidget *bconnect;
	GtkWidget *boxpacket;
	GtkWidget *label;
			
	//Inicio GTK
	gtk_init (&argc, &argv);
	
	
	//Creo ventana principal y le indico funcion de tratamiento de salida
	main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	
	gtk_signal_connect (GTK_OBJECT(main_window), 
			    "delete_event", 
			    GTK_SIGNAL_FUNC(Destroy),
			    NULL);
	gtk_window_set_title (GTK_WINDOW (main_window), "WitSummonLinux");
	gtk_container_border_width (GTK_CONTAINER(main_window), 30);
			
			
	boxpacket = gtk_vbox_new (FALSE, 0);
	
	
	//Creo etiqueta
	label = gtk_label_new ("Canal:");
	gtk_box_pack_start (GTK_BOX(boxpacket), label, FALSE, FALSE, 0);
	gtk_widget_show(label);
	
	
	//Creo la caja de texto para introducir el canal
	cchannel = gtk_entry_new();

	gtk_entry_set_text(GTK_ENTRY (cchannel), "peletier");

	
		
	gtk_box_pack_start (GTK_BOX(boxpacket), cchannel, FALSE, FALSE, 4);
	gtk_widget_show(cchannel);

	
	//Creo el boton Conectar, su etiqueta, asigno funcion y lo aado al cuadro  
	bconnect = gtk_button_new();
	lbutton=gtk_label_new("Conectar");
	
  	gtk_container_add (GTK_CONTAINER (bconnect), lbutton);
	gtk_widget_show(lbutton);
	
	gtk_signal_connect (GTK_OBJECT(bconnect), 
			    "clicked", 
			    GTK_SIGNAL_FUNC(DoConnect),
			    NULL);
			    
	gtk_box_pack_start (GTK_BOX(boxpacket), bconnect, FALSE, FALSE, 20);
	gtk_widget_show(bconnect);


	//Creo etiqueta de estado
	status = gtk_label_new ("Desconectado");
	gtk_box_pack_start (GTK_BOX(boxpacket), status, FALSE, FALSE, 0);
	gtk_misc_set_alignment (GTK_MISC (status), 0, 0.5);
	gtk_widget_show(status);
	
	//Aado el cuadro a la ventana padre
  	gtk_container_add (GTK_CONTAINER (main_window), boxpacket);
	
	//muestro el dialogo
	gtk_widget_show (boxpacket);
	gtk_widget_show (main_window);

	gtk_main();
	
	return 0;
}


//Funcion invocada al salir del programa
gint Destroy(GtkWidget *widget, gpointer gdata)
{
	g_print("Cerrando Aplicacion...\n");
	conectado=0;
	
	gtk_main_quit();
	
	return FALSE;
}
	
	
//Funcion de tratamiento de pulsacion del boton conectar
void DoConnect (GtkWidget *widget, gpointer gdata)
{
	struct sockaddr_in peletier , server;
	struct hostent *nslookup;
	fd_set scks;
	int sckPeletier ,sckServer;
	int count;
	char nameServer[]="libres.irc-hispano.org";
	char buffer[200];
	gchar *channel;
	
	struct timeval tv;

	
	//compruebo si estoy conectado
	if(conectado)
	{
		conectado = 0;

		return;
	}
	
	//Lo primero es obtener el nombre del canal
	channel=gtk_entry_get_text(GTK_ENTRY (cchannel));
	if(strlen(channel)==0)
	{
		gtk_label_set (GTK_LABEL(status), "Indique nombre del canal");
		
		return;
	}
	
	else if(channel[0]=='#')
	{
		gtk_label_set (GTK_LABEL(status), "Quita la # antes del nombre del canal");
		
		return;
	}
	
	//Conectamos a peletier.com
	sckPeletier=socket(AF_INET, SOCK_STREAM, 0);
	sckServer=socket(AF_INET, SOCK_STREAM, 0);
	
	bzero((char *)&peletier, sizeof(peletier));
	bzero((char *)&server, sizeof(server));

	//Relleno estructura de conexion a peletier.com	
	peletier.sin_family=AF_INET;
	peletier.sin_port=htons(5520);
	if ( (nslookup = gethostbyname("wit.peletier.com") ) == NULL) 
	{
		gtk_label_set (GTK_LABEL(status), "Error al resolver wit.peletier.com");
		
		return;
	}
	
	bcopy(nslookup->h_addr, (char *)&peletier.sin_addr, nslookup->h_length);


	//Relleno estructura de conexion al servidor de irc
	server.sin_family=AF_INET;
	server.sin_port=htons(6667);
	if ( (nslookup = gethostbyname(nameServer) ) == NULL) 
	{
		gtk_label_set (GTK_LABEL(status), "Error al resolver servidor");
		
		return;
	}
		
	bcopy(nslookup->h_addr, (char *)&server.sin_addr, nslookup->h_length);


	//Realizo las conexiones
	if(connect(sckPeletier, (struct sockaddr *)&peletier,sizeof(peletier))<0)
	{
		gtk_label_set (GTK_LABEL(status), "Error al conectar a peletier.com");
		
		return;
	}
		
	g_print("Conectado a peletier\n");

	if(connect(sckServer, (struct sockaddr *)&server,sizeof(server))<0)
	{
		gtk_label_set (GTK_LABEL(status), "Error al conectar a IRC");
		
		return;
	}

	g_print("Conectado a IRC\n");
	
	conectado=1;
	gtk_label_set (GTK_LABEL(lbutton), "Desconectar");	
	
	gtk_label_set (GTK_LABEL(status), "Conectado. Comunicando...");
	
		
	//Comienzo comunicacion con ambos. No es mas que seguir protocolo de comunicacion
	recv(sckPeletier, buffer, sizeof(buffer), 0);
	
	send(sckPeletier, "VERSION 1.1\n", 12, 0);

	recv(sckPeletier, buffer, sizeof(buffer), 0);

	send(sckPeletier, "USER anonymous connect\n", 23, 0);

	
	
	sprintf(buffer, "CHANNEL #%s\n", channel);
	send(sckPeletier, buffer, strlen(buffer), 0);

	send(sckPeletier, "DONE\n", 5, 0);
	send(sckPeletier, "CONNECTED\n", 10, 0);

	g_print("Terminado protocolo de inicio\n");
	
	//Escuchamos en los dos sockets
	gtk_label_set(GTK_LABEL(status), "Comunicacion establecida");

	//No me quedo esperando en el select, asi atiendo otros eventos
	tv.tv_sec=0;
	tv.tv_usec=0;
	
	while(conectado) 
	{
		FD_ZERO(&scks);
		FD_SET(sckServer, &scks);
		FD_SET(sckPeletier, &scks);

	        bzero(buffer, sizeof(buffer));
	
		if (select(10, &scks, NULL, NULL, &tv) < 0) 
		{
	        	gtk_label_set(GTK_LABEL(status), "Error en la comunicacion");
	        	
			return;
		}
		
		//Peletier.com -> Servidor IRC
		if (FD_ISSET(sckPeletier, &scks)) 
		{
		       	count = recv(sckPeletier, buffer, sizeof(buffer), 0);

		        send(sckServer, buffer, count, 0);
		}
		
		//Servidor IRC -> Peletier.com
		if (FD_ISSET(sckServer, &scks)) 
		{
		        count = recv(sckServer, buffer, sizeof(buffer), 0);
	
		        send(sckPeletier, buffer, count, 0);
		}
		
		//si no hay nada, atiendo resto de eventos
		while(gtk_events_pending())
			gtk_main_iteration();
	}

	FD_ZERO(&scks);
	
	close(sckPeletier);
	close(sckServer);
	
	gtk_label_set (GTK_LABEL(lbutton), "Conectar");	
	gtk_label_set(GTK_LABEL(status), "Desconectado");
	
}
